Subject: bug#60653: 30.0.50; tree-sitter: `treesit-[explore/inspect]-mode' can leak memory

From: Yuan Fu <[email-masked]>
Date: Sun, 8 Jan 2023 19:38:49 -0800

Mickey Petersen <[email-masked]> writes:

> If you enable either the `treesit-inspect-mode' or
> `treesit-explore-mode' and leave them to their devices, you may find
> that through excessive editing, particularly programmatically, that it
> can cause memory leaks over time.
>
> I am 90% certain those modes are responsible: if I do not use them,
> then I do not experience these issues. I have had the oomkiller reap
> the Emacs process as it simply balloons out of control over time.

Hmmm, maybe it’s just using a lot of memory. Emacs never returns memory
once it allocates them. Are you opening a lot of buffers? A tree-sitter
parse tree uses about 10x memory as the source text.

Yuan